* {
  box-sizing: border-box;
}

html, body {
  margin: 0;
  background-color: #323232;
  color: white;
  font-family: 'Ubuntu', sans-serif;
  position: relative;
}

.scroll-x {
  overflow-x: scroll;
}

.bar {
  position: sticky;
  top: 0;
  text-align: center;
  width: 100%;
  background-color: #434343;

  h1 {
    margin: 0;
    padding: 10px 0;
  }
}

.grid-text-wrapper {
  display: flex;
  justify-content: center;

  .grid-text-container {
    display: grid;
    justify-content: center;
    grid-template-rows: repeat(6, 57px auto);
    width: 45vw;
    margin: 20px 0;
    padding: 0 1vw 1vh;
    background-color: #434343;
    border-radius: 20px;

    h2 {
      z-index: 1;
      position: sticky;
      top: 0;
      display: flex;
      justify-content: center;
      align-items: center;
      margin: 0;
      background-color: #434343;
    }

    .text {
      line-height: 1.5rem;
      border-top: solid #323232;

      &:not(:last-child) {
        border-bottom: solid #323232;
        padding-bottom: 20px;
      }

      hr {
        border-style: solid;
      }

      .code-container-css {
        position: relative;
        padding: 10px;
        background-color: #282c34;
        border-radius: 5px;
        margin-top: 13px;
        margin-bottom: 13px;

        &::after {
          position: absolute;
          content: "CSS";
          color: #ee7077;
          font-family: 'Ubuntu', sans-serif;
          background-color: #434343;
          border-radius: 2px;
          font-size: 1.6rem;
          top: 8px;
          right: 8px;
          padding: 2px 2px 3px;
        }
      }

      .code-container-html {
        position: relative;
        padding: 10px;
        background-color: #282c34;
        border-radius: 5px;
        margin-top: 13px;
        margin-bottom: 13px;

        &::after {
          position: absolute;
          content: "HTML";
          color: #57b5c1;
          font-family: 'Ubuntu', sans-serif;
          background-color: #434343;
          border-radius: 2px;
          font-size: 1.6rem;
          top: 8px;
          right: 8px;
          padding: 2px 2px 3px;
        }
      }

      .punctuation {
        color: #a5b1bf;
      }

      .selector-class {
        color: #e4c07b;
      }

      .selector-id {
        color: #61a0ee;
      }

      .selector {
        color: #ee7077;
      }

      .property {
        color: #57b5c1;
      }

      .blue-property {
        color: #61a0ee;
      }

      .property-value {
        color: #d09966;
      }

      .tag {
        color: #ee7077;
      }

      .attribute {
        color: #e4c07b;
      }

      .attribute-value {
        color: #97c278;
      }

      .page-examples {
        position: relative;
        padding: 10px;
        background-color: #282c34;
        border-radius: 5px;
        margin-top: 13px;
        margin-bottom: 13px;

        li::marker {
          color: white;
        }

        &::after {
          position: absolute;
          content: "PAGE";
          font-family: 'Ubuntu', sans-serif;
          background-color: #434343;
          border-radius: 2px;
          font-size: 1.6rem;
          top: 8px;
          right: 8px;
          padding: 2px 2px 3px;
        }
      }

      #selector-example-1 p {
        color: red;
      }

      p > code, li > code, dl code {
        background-color: #282c34;
        font-family: 'Ubuntu', sans-serif;
        padding: 0 2px;
        border-radius: 2px;
      }

      #selector-example-2 {
        .red {
          color: red;
        }

        #blue {
          color: blue;
        }
      }

      li > pre, li > div {
        margin-right: 40px;
      }

      ul li::marker {
        color: #323232;
      }

      li {
        margin-top: 16px;
      }

      dd {
        margin-left: 20px;
      }

      #font-size-example-1 {
        #xx-small {
          font-size: xx-small;
        }

        #x-small {
          font-size: x-small;
        }

        #small {
          font-size: small;
        }

        #medium {
          font-size: medium;
        }

        #large {
          font-size: large;
        }

        #x-large {
          font-size: x-large;
        }

        #xx-large {
          font-size: xx-large;
        }
      }

      #font-size-example-2 {
        #em-2 {
          font-size: 2em;
        }

        #em-1 {
          font-size: 1em;
        }

        #em-half {
          font-size: .5em;
        }
      }

      #font-size-example-3 {
        #percent-200 {
          font-size: 200%;
        }

        #percent-100 {
          font-size: 100%;
        }

        #percent-50 {
          font-size: 50%;
        }
      }

      .page-examples-animated {
        position: relative;
        padding: 10px;
        background-color: #282c34;
        border-radius: 5px;
        margin-top: 13px;
        margin-bottom: 13px;

        &::after {
          position: absolute;
          content: "PAGE";
          font-family: 'Ubuntu', sans-serif;
          background-color: #434343;
          border-radius: 2px;
          font-size: 1.6rem;
          top: 8px;
          right: 8px;
          padding: 2px 2px 3px;
          opacity: 0;
          transition: opacity 20ms linear;
        }

        &:hover::after {
          opacity: 1;
        }
      }

      .grid-page-example-wrapper {
        display: grid;
        grid-template-columns: 1fr 1fr;
        grid-column-gap: 1vw;

        pre {
          max-height: 16vh;
        }

        #background-example-1, #background-example-2, #background-example-3, #background-example-4, #background-example-5, #background-example-6 {
          height: 30vh;
          border: dashed black 15px;
          background-color: white;
        }

        #background-example-1 {
          background-color: red;
          background-clip: content-box;
        }

        #background-example-2 {
          background-color: blue;
          background-clip: padding-box;
        }

        #background-example-3 {
          background-image: url("../assets/star.png"), linear-gradient(yellow, red);
          background-size: 50px;
        }

        #background-example-4 {
          background-image: url("../assets/star.png"), radial-gradient(purple, white);
          background-size: 100px;
        }

        #background-example-5 {
          background-image: url("../assets/star.png"), linear-gradient(to right, green, brown);
          background-size: 50px;
          background-repeat: space;
          background-position: bottom;
        }

        #background-example-6 {
          background-image: url("../assets/star.png"), radial-gradient(circle at 100% -100%, yellow, red);
          background-size: 200px;
          background-repeat: repeat-x;
          background-position: 25% 75%;
        }

        #border-example-1, #border-example-2, #border-example-3, #border-example-4 {
          height: 15vh;
        }

        #border-example-1 {
          border: dashed red;
        }

        #border-example-2 {
          border: 1rem solid;
        }

        #border-example-3 {
          border: thick double darkcyan;
        }

        #border-example-4 {
          border: 4mm ridge rgba(170, 50, 220, .6);
        }
      }

      #marker-example {
        li::marker {
          color: purple;
          content: "@";
        }
      }
    }
  }
}
